﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace PoolPattern
{
    class Program
    {
        static Random Ran = new Random();
        static FondPripojeni Fond = new FondPripojeni();

        static void Funkce()
        {
            int DelkaUspani = Ran.Next(0,250);
            Thread.Sleep(DelkaUspani);
            Console.WriteLine("Žádost o objekt");
            FondPripojeni.Proxy Zastupce=Fond.ZiskejPripojeniPockam();
            // SIMULACE PRÁCE S OBJEKTEM
            Thread.Sleep(500);
            Fond.VratitPripojeni(Zastupce);
            Console.WriteLine("Prace ukoncena");
        }
        static void FunkceIhned()
        {
            int DelkaUspani = Ran.Next(0, 100);
            Thread.Sleep(DelkaUspani);
            Console.WriteLine("Žádost o objekt");
            FondPripojeni.Proxy Zastupce = Fond.ZiskejPripojeniIhned();
            // SIMULACE PRÁCE S OBJEKTEM
            Thread.Sleep(2000);
            Fond.VratitPripojeni(Zastupce);
            Console.WriteLine("Prace ukoncena");
        }

        static void Main(string[] args)
        {
            for (int a = 0; a < 100; a++)
            {
                Thread vlakno = new Thread(Funkce);
                vlakno.Start();
            }
            for (int a = 0; a < 10; a++)
            {
                Thread vlakno = new Thread(FunkceIhned);
                vlakno.Start();
            }
            Console.ReadKey();
        }
    }
}
